plugins {
    id("java")
    id("com.gradleup.shadow") version "8.3.0"
}

group = "com.marcpg.bbm"
version = "0.1.0"
description = "Integration bridge between the Minecraft and Discord server of Big Bite Militia."

repositories {
    mavenLocal()
    mavenCentral()

    maven("https://marcpg.com/repo/")
}

dependencies {
    implementation("net.dv8tion:JDA:5.2.1")
    implementation("com.marcpg:libpg:0.1.3")
    implementation("org.postgresql:postgresql:42.7.3")
    implementation("mysql:mysql-connector-java:8.0.33")
}

tasks {
    build {
        dependsOn(shadowJar)
    }
    shadowJar {
        archiveClassifier.set("")
        manifest {
            attributes["Main-Class"] = "com.marcpg.bbm.BBMBot"
        }
    }
}
