package com.marcpg.bbm;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

public final class Config {
    public static String TOKEN;

    public static String MYSQL_URL;
    public static String MYSQL_USER;
    public static String MYSQL_PASSWD;

    public static void load() {
        Properties properties = new Properties();

        try (FileInputStream stream = new FileInputStream("pg.properties")) {
            properties.load(stream);
        } catch (IOException e) {
            System.err.println("Couldn't load BotPG configuration (pg.properties): " + e);
        }

        // General configuration
        TOKEN = properties.getProperty("token");

        // Database related configuration
        MYSQL_URL = properties.getProperty("psql.url");
        MYSQL_USER = properties.getProperty("psql.user");
        MYSQL_PASSWD = properties.getProperty("psql.passwd");
    }
}
