plugins {
    id("java")
    id("com.gradleup.shadow") version "8.3.0"
    id("xyz.jpenilla.run-paper") version "2.2.3"
}

group = "com.marcpg.bbm"
version = "0.1.0"
description = "Factions plugin for the Big Bite Militia server, by MarcPG."

repositories {
    mavenLocal()
    mavenCentral()

    maven("https://marcpg.com/repo")
    maven("https://repo.xenondevs.xyz/releases")
    maven("https://repo.papermc.io/repository/maven-public")
    maven("https://repo.codemc.org/repository/maven-public")
}

dependencies {
    compileOnly("io.papermc.paper:paper-api:1.21.1-R0.1-SNAPSHOT")
    compileOnly("net.milkbowl.vault:VaultUnlockedAPI:2.7")
    implementation("com.marcpg:libpg:0.1.3")
    implementation("mysql:mysql-connector-java:8.0.33")
    implementation("xyz.xenondevs.invui:invui:1.41")
}

tasks {
    build {
        dependsOn(shadowJar)
    }
    runServer {
        dependsOn(shadowJar)
        minecraftVersion("1.21.1")
    }
    shadowJar {
        archiveClassifier.set("")
    }
    processResources {
        exclude("en_US.properties")
        filter {
            it.replace("\${version}", version.toString())
        }
    }
}
