package com.marcpg.bbm.factions;

import com.marcpg.libpg.storing.Cord;
import com.marcpg.libpg.storing.CordMinecraftAdapter;
import com.marcpg.libpg.storing.Pair;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.tree.LiteralCommandNode;
import io.papermc.paper.command.brigadier.CommandSourceStack;
import io.papermc.paper.plugin.lifecycle.event.types.LifecycleEvents;
import net.milkbowl.vault2.economy.Economy;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.slf4j.Logger;
import xyz.xenondevs.invui.InvUI;

import java.util.Objects;

@SuppressWarnings("UnstableApiUsage")
public final class BBMFactions extends JavaPlugin {
    public static BBMFactions PLUGIN;
    public static Logger LOG;
    public static FileConfiguration CONFIG;
    public static Economy ECONOMY;

    public static Location spawn;

    @Override
    public void onEnable() {
        PLUGIN = this;
        LOG = getSLF4JLogger();
        config();
        ECONOMY = Objects.requireNonNull(getServer().getServicesManager().getRegistration(Economy.class)).getProvider();

        InvUI.getInstance().setPlugin(this);
        BountySystem.load();

        getServer().getPluginManager().registerEvents(new BasicEvents(), this);
        getServer().getPluginManager().registerEvents(new BountySystem(), this);
        getLifecycleManager().registerEventHandler(LifecycleEvents.COMMANDS, event -> {
            event.registrar().register(BountySystem.bountyCommand());
            event.registrar().register(spawnCommand());
        });
    }

    void config() {
        saveDefaultConfig();
        CONFIG = getConfig();

        Pair<Cord, Cord> spawnCorners = Cord.corners(Cord.ofList(CONFIG.getIntegerList("spawn.corner1")), Cord.ofList(CONFIG.getIntegerList("spawn.corner2")));
        BasicEvents.spawnLow = spawnCorners.left();
        BasicEvents.spawnHigh = spawnCorners.right();

        Pair<Cord, Cord> pvpCorners = Cord.corners(Cord.ofList(CONFIG.getIntegerList("pvp.corner1")), Cord.ofList(CONFIG.getIntegerList("pvp.corner2")));
        BasicEvents.pvpLow = pvpCorners.left();
        BasicEvents.pvpHigh = pvpCorners.right();

        spawn = CordMinecraftAdapter.toLocation(Cord.ofList(CONFIG.getIntegerList("spawn")), Objects.requireNonNull(Bukkit.getWorld("world")));
    }

    public static LiteralCommandNode<CommandSourceStack> spawnCommand() {
        return LiteralArgumentBuilder.<CommandSourceStack>literal("spawn")
                .requires(source -> source.getSender() instanceof Player)
                .executes(context -> {
                    ((Player) context.getSource()).teleport(spawn);
                    return 1;
                })
                .build();
    }
}
