package com.marcpg.bbm.factions;

import com.destroystokyo.paper.event.block.BlockDestroyEvent;
import com.marcpg.libpg.storing.Cord;
import com.marcpg.libpg.storing.CordMinecraftAdapter;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockCanBuildEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntitySpawnEvent;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

public class BasicEvents implements Listener {
    public static Cord spawnLow;
    public static Cord spawnHigh;
    public static Cord pvpLow;
    public static Cord pvpHigh;

    @SuppressWarnings("UnstableApiUsage")
    @EventHandler(ignoreCancelled = true)
    public void onEntityDamage(@NotNull EntityDamageEvent event) {
        if (event.getCause() == EntityDamageEvent.DamageCause.FALL && event.getEntity() instanceof Player player) {
            Cord cord = CordMinecraftAdapter.ofLocation(player.getLocation());
            if (cord.inBounds(spawnLow, spawnHigh)) {
                event.setCancelled(true);
            }
        } else if (event.getDamageSource().getCausingEntity() instanceof Player player) {
            Cord cord = CordMinecraftAdapter.ofLocation(player.getLocation());
            if (cord.inBounds(spawnLow, spawnHigh) && !cord.inBounds(pvpLow, pvpHigh)) {
                event.setCancelled(true);
                player.sendActionBar(Component.text("You can't hit players in the spawn area!", NamedTextColor.RED));
            }
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void onBlockBreak(@NotNull BlockBreakEvent event) {
        Block block = event.getBlock();
        if (CordMinecraftAdapter.ofLocation(block.getLocation()).inBounds(spawnLow, spawnHigh)) {
            event.setCancelled(true);
            event.getPlayer().sendActionBar(Component.text("You can't destroy blocks in the spawn area!", NamedTextColor.RED));
        } else if (block.getType() == Material.SPAWNER && event.getPlayer().getInventory().getItemInMainHand().containsEnchantment(Enchantment.SILK_TOUCH)) {
            event.setDropItems(true);
            block.getWorld().dropItemNaturally(block.getLocation(), new ItemStack(Material.SPAWNER));
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void onBlockDestroy(@NotNull BlockDestroyEvent event) {
        if (CordMinecraftAdapter.ofLocation(event.getBlock().getLocation()).inBounds(spawnLow, spawnHigh))
            event.setCancelled(true);
    }

    @EventHandler(ignoreCancelled = true)
    public void onBlockPlace(@NotNull BlockPlaceEvent event) {
        if (CordMinecraftAdapter.ofLocation(event.getBlock().getLocation()).inBounds(spawnLow, spawnHigh))
            event.setCancelled(true);
    }

    @EventHandler(ignoreCancelled = true)
    public void onBlockCanBuild(@NotNull BlockCanBuildEvent event) {
        if (CordMinecraftAdapter.ofLocation(event.getBlock().getLocation()).inBounds(spawnLow, spawnHigh))
            event.setBuildable(false);
    }

    @EventHandler(ignoreCancelled = true)
    public void onEntitySpawn(@NotNull EntitySpawnEvent event) {
        if (CordMinecraftAdapter.ofLocation(event.getLocation()).inBounds(spawnLow, spawnHigh))
            event.setCancelled(true);
    }
}
