plugins {
    id("java")
    id("com.gradleup.shadow") version "8.3.0"
    id("xyz.jpenilla.run-paper") version "2.2.3"
}

group = "com.marcpg.bbm"
version = "0.1.0"
description = "Lobby plugin for the Big Bite Militia server, made by MarcPG."

repositories {
    mavenLocal()
    mavenCentral()

    maven("https://marcpg.com/repo/")
    maven("https://repo.papermc.io/repository/maven-public/")
    maven("https://repo.xenondevs.xyz/releases")
}

dependencies {
    compileOnly("io.papermc.paper:paper-api:1.21.1-R0.1-SNAPSHOT")
    implementation("xyz.xenondevs.invui:invui:1.41")
    implementation("com.marcpg:libpg:0.1.3")
}

tasks {
    build {
        dependsOn(shadowJar)
    }
    runServer {
        dependsOn(shadowJar)
        minecraftVersion("1.21.1")
    }
    shadowJar {
        archiveClassifier.set("")
        manifest {
            // Required for InvUI to properly work. Sadly, it will make paper remap the plugin, which takes a while.
            attributes["paperweight-mappings-namespace"] = "spigot"
        }
    }
    processResources {
        filter {
            it.replace("\${version}", version.toString())
        }
    }
}
