package com.marcpg.bbm.lobby;

import io.papermc.paper.plugin.lifecycle.event.types.LifecycleEvents;
import org.bukkit.Location;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;
import org.slf4j.Logger;
import xyz.xenondevs.invui.InvUI;

@SuppressWarnings("UnstableApiUsage")
public final class BBMLobby extends JavaPlugin implements Listener {
    public static BBMLobby PLUGIN;
    public static Logger LOG;
    public static FileConfiguration CONFIG;

    @Override
    public void onEnable() {
        saveDefaultConfig();

        PLUGIN = this;
        LOG = getSLF4JLogger();
        CONFIG = getConfig();

        InvUI.getInstance().setPlugin(this);

        getServer().getMessenger().registerOutgoingPluginChannel(this, "BungeeCord");
        getServer().getPluginManager().registerEvents(new Compass(), this);
        getServer().getPluginManager().registerEvents(this, this);

        getLifecycleManager().registerEventHandler(LifecycleEvents.COMMANDS, event -> {
            event.registrar().register(Compass.joinCommand());
        });
    }

    @EventHandler(ignoreCancelled = true)
    public void onPlayerMove(@NotNull PlayerMoveEvent event) {
        Location highestLocation = event.getTo().toHighestLocation();
        if (event.hasChangedBlock() && (highestLocation == null || highestLocation.y() <= -50)) {
            event.setCancelled(true);
        }
    }
}
