package com.marcpg.bbm.lobby.item;

import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.item.ItemProvider;
import xyz.xenondevs.invui.item.builder.ItemBuilder;
import xyz.xenondevs.invui.item.impl.AbstractItem;

import java.util.function.BiConsumer;

public class ClickItem extends AbstractItem {
    protected final ItemStack item;
    protected final BiConsumer<Player, InventoryClickEvent> clickConsumer;

    public ClickItem(ItemStack item, BiConsumer<Player, InventoryClickEvent> clickConsumer) {
        this.item = item;
        this.clickConsumer = clickConsumer;
    }

    @Override
    public ItemProvider getItemProvider() {
        return new ItemBuilder(item);
    }

    @Override
    public void handleClick(@NotNull ClickType clickType, @NotNull Player player, @NotNull InventoryClickEvent event) {
        clickConsumer.accept(player, event);
    }
}
