plugins {
    id("java")
    id("com.gradleup.shadow") version "8.3.0"
    id("xyz.jpenilla.run-velocity") version "2.2.3"
}

group = "com.marcpg.bbm"
version = "0.1.0"
description = "Proxy plugin for the Big Bite Militia server, by MarcPG."

java.sourceCompatibility = JavaVersion.VERSION_21
java.targetCompatibility = JavaVersion.VERSION_21

repositories {
    mavenLocal()
    mavenCentral()

    maven("https://marcpg.com/repo/")
    maven("https://repo.papermc.io/repository/maven-public/")
}

dependencies {
    compileOnly("com.velocitypowered:velocity-api:3.4.0-SNAPSHOT")
    implementation("mysql:mysql-connector-java:8.0.33")
    implementation("com.marcpg:libpg:0.1.3")
}

tasks {
    build {
        dependsOn(shadowJar)
    }
    runVelocity {
        dependsOn(shadowJar)
        velocityVersion("3.4.0-SNAPSHOT")
    }
    shadowJar {
        archiveClassifier.set("")
    }
}
