package com.marcpg;

import com.google.inject.Inject;
import com.marcpg.libpg.data.database.sql.AutoCatchingSQLConnection;
import com.marcpg.libpg.data.database.sql.SQLConnection;
import com.velocitypowered.api.command.BrigadierCommand;
import com.velocitypowered.api.command.CommandManager;
import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.proxy.ProxyInitializeEvent;
import com.velocitypowered.api.plugin.Plugin;
import com.velocitypowered.api.proxy.ProxyServer;
import org.slf4j.Logger;

import java.util.UUID;

@Plugin(
        id = "bbmproxy",
        name = "BBMProxy",
        version = "0.1.0",
        description = "Proxy plugin for the Big Bite Militia server, by MarcPG.",
        url = "https://marcpg.com/",
        authors = { "MarcPG" }
)
public class BBMProxy {
    public static Logger LOG;
    public static ProxyServer SERVER;
    public static AutoCatchingSQLConnection<UUID> DATABASE;

    @Inject
    public BBMProxy(Logger logger, ProxyServer server) {
        LOG = logger;
        SERVER = server;
    }

    @Subscribe
    public void onProxyInitialize(ProxyInitializeEvent event) {
        DATABASE = connectPlayerDataDatabase("playerdata");

        CommandManager cm = SERVER.getCommandManager();
        cm.register(cm.metaBuilder("server-stats").plugin(this).aliases("admin-stats").build(), new BrigadierCommand(ServerStats.serverStatsCommand()));

        SERVER.getEventManager().register(this, new ServerStats());
    }

    AutoCatchingSQLConnection<UUID> connectPlayerDataDatabase(String table) {
        try {
            return new AutoCatchingSQLConnection<>(
                    SQLConnection.DatabaseType.POSTGRESQL,
                    "5.78.106.41",
                    3306,
                    "s8348_bbm",
                    "u8348_Ff3OkAOugQ",
                    "Q8BCgDXOYhLK7AA9v7=nAYp^",
                    table,
                    "uuid",
                    e -> LOG.error("Database error: {}", e.getMessage())
            );
        } catch (Exception e) {
            LOG.error("Couldn't establish connection to playerdata database!", e);
            return null;
        }
    }
}